<?php

require_once dirname(__FILE__) . str_replace('/', DIRECTORY_SEPARATOR, '/../../PrizmPayClient/PrizmPayClient.php');
require_once dirname(__FILE__) . str_replace('/', DIRECTORY_SEPARATOR, '/../../PrizmPayClient/PrizmPayClient_PP.php');

/**
 * Prizmpay Checkout Controller
 *
 */
class Prizm_Prizmpay_PrizmpayController extends Mage_Core_Controller_Front_Action {

    const PARAM_NAME_REJECT_URL = 'reject_url';

    protected function _expireAjax() {
        if (!Mage::getSingleton('checkout/session')->getQuote()->hasItems()) {
            $this->getResponse()->setHeader('HTTP/1.1', '403 Session Expired');
            exit;
        }
    }

    public function datafeedAction() {
        /* @var $prizmpay Prizm_Prizmpay_Model_Prizmpay */
        $prizmpay = Mage::getModel('prizmpay/prizmpay');
        $prizmpay->handleDatafeed();
    }

    public function redirectAction() {
        $session = Mage::getSingleton('checkout/session');
        $session->setPrizmpayQuoteId($session->getQuoteId());
        $this->getResponse()->setBody($this->getLayout()->createBlock('prizmpay/redirect')->toHtml());
        $session->unsQuoteId();
    }

    public function cancelAction() {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getPrizmpayQuoteId(true));
        if ($session->getLastRealOrderId()) {
            $order = Mage::getModel('sales/order')->loadByIncrementId($session->getLastRealOrderId());
            if ($order->getId()) {
                $order->cancel()->save();
                $comment = "You have canceled your order";
                $order->sendOrderUpdateEmail(true, $comment);
            }
        }
        $this->_redirect('checkout/cart');
    }

    public function successAction() {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getPrizmpayQuoteId(true));
        Mage::getSingleton('checkout/session')->getQuote()->setIsActive(false)->save();
        $order   = Mage::getModel('sales/order');
        $order->load(Mage::getSingleton('checkout/session')->getLastOrderId());
        Mage::getSingleton('checkout/session')->unsQuoteId();
        $this->_redirect('checkout/onepage/success');
    }

    public function failureAction() {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getPrizmpayQuoteId(true));
        $this->_redirect('checkout/onepage/failure');
    }

}
